<template>
    <div class="content">
        <div class="intro-y flex flex-col sm:flex-row items-center my-8">
            <div class="mr-auto">
                <h2 class="text-lg font-medium mr-auto">
                    Data Level
                </h2>
            </div>
        </div>
        <div class="grid grid-cols-12 gap-6 mt-5">
        <Loader :loading="showLoader" />
            <div class="intro-y col-span-12 flex flex-wrap sm:flex-nowrap items-center mt-2">
                <a href="javascript:;" class="btn btn-primary shadow-md mr-2" data-tw-toggle="modal"
                    data-tw-target="#modal-role">Add New Level</a>
                <div id="modal-role" class="modal" tabindex="-1" aria-hidden="true">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <!-- BEGIN: Modal Header -->
                            <div class="modal-header">
                                <h2 class="font-medium text-base mr-auto">
                                    Form Level
                                </h2>
                            </div>
                            <!-- END: Modal Header -->
                            <!-- BEGIN: Modal Body -->
                            <form @submit.prevent="submit">
                                <div class="modal-body grid grid-cols-12 gap-4 gap-y-3">
                                    <div class="col-span-12 sm:col-span-12">
                                        <label for="modal-form-1" class="form-label">Name</label>
                                        <input id="modal-form-1" type="text" class="form-control" v-model="name"
                                            placeholder="Insert Name">
                                    </div>
                                </div>
                                <!-- END: Modal Body -->
                                <!-- BEGIN: Modal Footer -->
                                <div class="modal-footer text-right">
                                    <button type="button" data-tw-dismiss="modal"
                                        class="btn btn-outline-secondary w-20 mr-1">Cancel</button>
                                    <button type="submit" class="btn btn-primary w-20">{{label}}</button>
                                </div>
                            </form>
                            <!-- END: Modal Footer -->
                        </div>
                    </div>
                </div>
                <div class="hidden md:block mx-auto text-gray-600">Showing {{record}} of {{totalRecords}}
                    entries</div>
                <div class="w-full sm:w-auto mt-3 sm:mt-0 sm:ml-auto md:ml-0">
                    <div class="w-56 relative text-gray-700 dark:text-gray-300">
                        <input type="text" v-model="search" class="form-control w-56 box pr-10 placeholder-theme-8"
                            placeholder="Search..." @change="getData()" >
                        <vue-feather class="w-4 h-4 absolute my-auto inset-y-0 mr-3 right-0" type="search">
                        </vue-feather>
                    </div>
                </div>
            </div>
            <!-- BEGIN: Data List -->
            <div class="intro-y col-span-12 overflow-auto lg:overflow-visible">
                <table class="table table-report -mt-2">
                    <thead>
                        <tr>
                            <th class="whitespace-nowrap">Name</th>
                            <th class=" whitespace-nowrap">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr class="intro-x" v-for="role in listItems" :key="role.id">
                            <td>
                                <a href="" class="font-medium whitespace-nowrap">{{role.name}}</a>
                            </td>
                            <td class="table-report__action w-56">
                                <div class="flex justify-center items-center">
                                    <a class="flex items-center mr-3" href="javascript:;" data-tw-toggle="modal"
                                        data-tw-target="#modal-role" @click="setDetail(role.id)">
                                        <vue-feather class="w-4 h-4 mr-1" type="edit"></vue-feather> Edit
                                    </a>
                                    <a class="flex items-center text-theme-24" href="javascript:;"
                                        data-tw-toggle="modal" data-tw-target="#delete-confirmation-modal"
                                        @click="setID(role.id)">
                                        <vue-feather class="w-4 h-4 mr-1" type="trash"></vue-feather> Delete
                                    </a>
                                </div>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <!-- END: Data List -->
            <!-- BEGIN: Pagination -->
            <div class="intro-y col-span-12 flex flex-wrap sm:flex-row sm:flex-nowrap items-center">
                <Pagination v-if="listItems" :total-pages="totalPages" :per-page="recordsPerPage" :current-page="page"
                    @pagechanged="onPageChange" />
                <select class="w-20 form-select box mt-3 sm:mt-0" v-model="recordsPerPage" @change="changeLimit()">
                    <option value=10>10</option>
                    <option value=20>20</option>
                    <option value=30>30</option>
                    <option value=50>50</option>
                </select>
            </div>
            <!-- END: Pagination -->
        </div>
        <div id="delete-confirmation-modal" class="modal" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-body p-0">
                        <div class="p-5 text-center">
                            <vue-feather class="w-16 h-16 text-theme-24 mx-auto mt-3" type="x-circle"></vue-feather>
                            <div class="text-3xl mt-5">Are you sure?</div>
                            <div class="text-gray-600 mt-2">
                                Do you really want to delete these records?
                                <br>
                                This process cannot be undone.
                            </div>
                        </div>
                        <div class="px-5 pb-8 text-center">
                            <button type="button" data-tw-dismiss="modal"
                                class="btn btn-outline-secondary w-24 mr-1">Cancel</button>
                            <button type="button" class="btn btn-danger w-24" @click="deleteRole">Delete</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import Pagination from '@/components/pagination/Main.vue'
    import Loader from '@/components/pagination/Loader.vue'
    import Toastify from 'toastify-js';

    export default {
        name: 'DataRole',
        components: {
            Pagination,
            Loader
        },
        data() {
            return {
                listItems: [],
                page: 1,
                totalPages: 0,
                totalRecords: 0,
                recordsPerPage: 10,
                record : 10,
                name: "",
                search: "",
                id: 0,
                maxPage: 50,
                edit: false,
                label: "Save"
            }
        },
        methods: {
            setID(id) {
                this.id = id
            },
            setPage(page) {
                this.getData()
            },
            changeLimit() {
                this.getData()
            },
            onPageChange(page) {
                this.page = page
                this.getData()
            },
            async setDetail(id) {
                this.showLoader = true
                this.$axios.get(`/role/${id}/detail`, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    })
                    .then((response) => {
                        this.showLoader = false
                        const data = response.data.data
                        this.id = id
                        this.name = data.name
                        this.label = "Update"
                        this.edit = true
                    }).catch((error) => {
                        console.log(error);
                    });
            },
            async getData() {
                this.showLoader = true
                const data = {
                    offset: this.page,
                    limit: this.recordsPerPage,
                    search: this.search
                }
                this.$axios.get(`/role`, {
                        params: data,
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    })
                    .then((response) => {
                        this.showLoader = false
                        this.listItems = response.data.data.data ? response.data.data.data : []
                        this.totalPages = Math.ceil(response.data.data.total / this.recordsPerPage)
                        this.totalRecords = response.data.data.total
                        this.record = this.listItems.length
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
            },
            submit: async function () {
                if (this.name == "") {
                    Toastify({
                        text: `ERROR : name is empty`,
                        duration: 3000,
                        newWindow: true,
                        close: true,
                        gravity: "top",
                        position: "right",
                        stopOnFocus: true,
                        className: "toastify-content",
                    }).showToast();

                    return
                }   
                
                if (this.edit) {
                    this.$axios.put(`/role/${this.id}/update`, {
                        name: this.name,
                    }, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Update Level Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                        setTimeout(function () {
                            window.location.reload()
                        }, 1000);
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                } else {
                    this.$axios.post(`/role`, {
                        name: this.name,
                    }, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Create Level Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                        setTimeout(function () {
                            window.location.reload()
                        }, 1000);
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                }
            },
            async deleteRole() {
                this.$axios.delete(`/role/${this.id}/delete`, {
                    headers: {
                        "Token": this.$store.state.user.token,
                        "User-ID": this.$store.state.user.user_id
                    }
                }).then(() => {
                    Toastify({
                        text: `Create Level Success`,
                        duration: 3000,
                        newWindow: true,
                        close: true,
                        gravity: "top",
                        position: "right",
                        stopOnFocus: true,
                        className: "toastify-content",
                    }).showToast();
                    setTimeout(function () {
                        window.location.reload()
                    }, 1000);
                }).catch((error) => {
                    Toastify({
                        text: `ERROR : ${error.response.data.message}`,
                        duration: 3000,
                        newWindow: true,
                        close: true,
                        gravity: "top",
                        position: "right",
                        stopOnFocus: true,
                        className: "toastify-content",
                    }).showToast();
                });
            }
        },
        mounted() {
            this.getData()
        }
    }
</script>